package org.netkernel.module.standard.builtin;

import org.netkernel.layer0.meta.IPrototypeParameterMeta;
import org.netkernel.layer0.meta.impl.DefaultPrototypeMeta;
import org.netkernel.layer0.meta.impl.PrototypeParameterMetaImpl;

public class ImportPrototype extends DefaultPrototypeMeta
{
	public static final String PARAM_URI="uri";
	public static final String PARAM_MAX="version-max";
	public static final String PARAM_MIN="version-min";
	public static final String PARAM_PRIVATE="private";
	public static final String PARAM_OPTIONAL="optional";
	
	public static IPrototypeParameterMeta[] sPrototypeParameters = new IPrototypeParameterMeta[]
    {	new PrototypeParameterMetaImpl(PARAM_URI,"URI of space to import", String.class,IPrototypeParameterMeta.NO_DEFAULT),
		new PrototypeParameterMetaImpl(PARAM_MAX,"Maximum version qualifier of imported space", String.class,null),
		new PrototypeParameterMetaImpl(PARAM_MIN,"Minimum version qualifier of imported space", String.class,null),
		new PrototypeParameterMetaImpl(PARAM_PRIVATE,Boolean.class,false),
		new PrototypeParameterMetaImpl(PARAM_OPTIONAL,"If true no warning is raised if import not found",Boolean.class,false)
  	};
	
	public ImportPrototype()
	{	super(Import.class,"Import");
	}

	public String getName()
	{	return "Import";
	}

	public IPrototypeParameterMeta[] getParameters()
	{	return sPrototypeParameters;
	}

	public String getDescription()
	{	return "Import an external space";
	}
}