package org.netkernel.module.standard.builtin;

import org.netkernel.container.IKernel;
import org.netkernel.layer0.bnf.BNFGrammarFactory;
import org.netkernel.layer0.bnf.IGrammarGroup;
import org.netkernel.layer0.meta.impl.EndpointMetaBuilder;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.util.RequestBuilder;
import org.netkernel.module.standard.endpoint.StandardMonoEndpointImpl;
import org.netkernel.request.IRequest;
import org.netkernel.urii.ISpace;
import org.w3c.dom.Element;

public class LiteralResourceEndpoint extends StandardMonoEndpointImpl
{
	public LiteralResourceEndpoint()
	{	declareThreadSafe();
		declareParameters(LiteralResourcePrototype.sPrototypeParameters);
	}
	
	public void onCommissionEndpoint(IKernel aKernel, ISpace aSpace) throws Exception
	{	super.onCommissionEndpoint(aKernel, aSpace);

		Element e = (Element)getParameter("config");
		String uri=e.getAttribute("uri");
		String id=e.getAttribute("id");
		if (id.length()>0)
		{	mId=id;
		}
		EndpointMetaBuilder b = new EndpointMetaBuilder();
		b.setVerbs(IRequest.VERB_SOURCE|IRequest.VERB_EXISTS);
		IGrammarGroup root =  BNFGrammarFactory.createGroup(null);
		BNFGrammarFactory.createText(root,uri);
		b.setGrammarRoot(root);
		b.setName("Literal "+uri);
		
		boolean isPrivate=e.getAttribute("private").equals("true");
		if (isPrivate)
		{	b.addField(PrivateFilterEndpoint.KEY_PRIVATE, Boolean.TRUE);
		}
		
		mMeta=b.getMeta(aKernel.getLogger());
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	Element e = (Element)getParameter("config");
		Object[] l=RequestBuilder.parseLiteral(e, getSpace().getClassLoader(), aContext);
		aContext.createResponseFrom(l[0]);
	}
	
	public void onExists(INKFRequestContext aContext)
	{	aContext.createResponseFrom(true);		
	}
	
	public String toString()
	{	return "Literal";
	}
}
